; 
    include \masm32\include\masm32rt.inc

    Paint_Proc  PROTO :DWORD,:DWORD
    _GS         PROTO :DWORD,:DWORD,:DWORD
    _RGB        PROTO :BYTE,:BYTE,:BYTE
    _Rectangle  PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

; 
    .data
        hInst     dd          0
        hWnd      dd          0
        wc        WNDCLASSEX  <>
        msg       MSG         <>
        className db          "gray_scale_test"
    .code
; 
start:
; 
    ;invoke _GS, 255, 0, 0
    ;MsgBox 0,uhex$(eax),"red",0     ; should be 4C4C4Ch
    ;invoke _GS, 0, 255, 0     
    ;MsgBox 0,uhex$(eax),"green",0   ; should be 969696h
    ;invoke _GS, 0, 0, 255
    ;MsgBox 0,uhex$(eax),"blue",0    ; should be 1C1C1Ch

    mov   hInst, rv(GetModuleHandle, NULL)
    mov   wc.cbSize,        sizeof WNDCLASSEX
    mov   wc.style,         CS_HREDRAW or CS_VREDRAW \
                              or CS_BYTEALIGNWINDOW
    mov   wc.lpfnWndProc,   OFFSET WndProc
    mov   wc.cbClsExtra,    NULL
    mov   wc.cbWndExtra,    NULL
    m2m   wc.hInstance,     hInst
    invoke GetStockObject, BLACK_BRUSH
    mov   wc.hbrBackground, eax
    mov   wc.lpszMenuName,  NULL
    mov   wc.lpszClassName, OFFSET className
    mov   wc.hIcon,         NULL
    mov   wc.hCursor,       NULL
    mov   wc.hIconSm,       0
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx,  WS_EX_OVERLAPPEDWINDOW,
                            ADDR className,
                            chr$("Grayscale Test"),
                            WS_OVERLAPPEDWINDOW,
                            0,0,600,400,
                            NULL, NULL,
                            hInst, NULL
    mov   hWnd, eax
    invoke ShowWindow, hWnd, SW_SHOWNORMAL
    invoke UpdateWindow, hWnd
  msgLoop:
    invoke GetMessage, ADDR msg, NULL, 0, 0
    .IF (eax != 0)
        invoke TranslateMessage, ADDR msg
        invoke DispatchMessage, ADDR msg
        jmp   msgLoop
    .ENDIF
    exit msg.wParam
; 
WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    LOCAL hDC :DWORD
    LOCAL ps  :PAINTSTRUCT
    
    .IF (uMsg == WM_DESTROY)
        invoke PostQuitMessage, NULL
        return 0
    .ELSEIF (uMsg == WM_PAINT)
        invoke BeginPaint, hWin, ADDR ps
        mov hDC, eax
        invoke Paint_Proc, hWin, hDC
        invoke EndPaint, hWin, ADDR ps
        return 0
    .ENDIF
    invoke DefWindowProc, hWin, uMsg, wParam, lParam
    ret
WndProc endp
; 
Paint_Proc proc hWin:DWORD, hDC:DWORD
    invoke GetStockObject, DC_PEN
    invoke SelectObject, hDC, eax
    invoke GetStockObject, DC_BRUSH
    invoke SelectObject, hDC, eax

    mov   ebx, 255
    mov   edi, 30
    .WHILE (ebx)
        invoke _RGB, bl, 0, 0
        invoke SetDCPenColor, hDC, eax
        invoke _RGB, bl, 0, 0
        invoke SetDCBrushColor, hDC, eax
        invoke _Rectangle, hDC, edi, 30, 2, 40
        sub   ebx, 1
        add   edi, 2
    .ENDW
    mov   ebx, 255
    mov   edi, 30
    .WHILE (ebx)
        invoke _GS, bl, 0, 0
        invoke SetDCPenColor, hDC, eax
        invoke _GS, bl, 0, 0
        invoke SetDCBrushColor, hDC, eax
        invoke _Rectangle, hDC, edi, 80, 2, 40
        sub   ebx, 1
        add   edi, 2
    .ENDW

    mov   ebx, 255
    mov   edi, 30
    .WHILE (ebx)
        invoke _RGB, 0, bl, 0
        invoke SetDCPenColor, hDC, eax
        invoke _RGB, 0, bl, 0
        invoke SetDCBrushColor, hDC, eax
        invoke _Rectangle, hDC, edi, 140, 2, 40
        sub   ebx, 1
        add   edi, 2
    .ENDW
    mov   ebx, 255
    mov   edi, 30
    .WHILE (ebx)
        invoke _GS, 0, bl, 0
        invoke SetDCPenColor, hDC, eax
        invoke _GS, 0, bl, 0
        invoke SetDCBrushColor, hDC, eax
        invoke _Rectangle, hDC, edi, 190, 2, 40
        sub   ebx, 1
        add   edi, 2
    .ENDW

    mov   ebx, 255
    mov   edi, 30
    .WHILE (ebx)
        invoke _RGB, 0, 0, bl
        invoke SetDCPenColor, hDC, eax
        invoke _RGB, 0, 0, bl
        invoke SetDCBrushColor, hDC, eax
        invoke _Rectangle, hDC, edi, 250, 2, 40
        sub   ebx, 1
        add   edi, 2
    .ENDW
    mov   ebx, 255
    mov   edi, 30
    .WHILE (ebx)
        invoke _GS, 0, 0, bl
        invoke SetDCPenColor, hDC, eax
        invoke _GS, 0, 0, bl
        invoke SetDCBrushColor, hDC, eax
        invoke _Rectangle, hDC, edi, 300, 2, 40
        sub   ebx, 1
        add   edi, 2
    .ENDW

    ret
Paint_Proc endp
; 
_GS proc red:DWORD, green:DWORD, blue:DWORD
    LOCAL rval:DWORD
    fild  red
    fld8  0.30
    fmul
    fild  green
    fld8  0.59
    fmul
    fild  blue
    fld8  0.11
    fmul
    fadd
    fadd
    fistp rval
    mov   eax, rval
    rol   eax, 8
    or    eax, rval
    rol   eax, 8
    or    eax, rval
    ret
_GS endp
; 
_RGB proc red:BYTE, green:BYTE, blue:BYTE
    mov ah, blue
    mov al, green
    rol eax, 8
    mov al, red
    ret    
_RGB endp
; 
_Rectangle proc hDC:DWORD, x:DWORD, y:DWORD, w:DWORD, h:DWORD
    mov   eax, x
    add   eax, w
    mov   edx, y
    add   edx, h    
    invoke Rectangle, hDC, x, y, eax, edx
    ret
_Rectangle endp
; 
end start
